\ LexInput.fth the LexGen input file for an ANS Forth word scanner

s" stt.fth" setOutputFile
127 setMaxChar

\ -----------------------------------------------------------------------------
\ The definition of character classes and regular expressions

0 bl [..] charClass ws  \ Strictly speaking only bl is ANS Forth white space
ws <+> regexp white-space

char 0 char 9 [..] charClass digit
char + [new] char - [+] charClass sign

sign <?> digit <+> <.> 'char' . <?> <.> regexp number

sign <?> digit <+> <.> 'char' . digit <*> <.> <?> <.> regexp significand
'char' E 'char' e <|> sign <?> <.> digit <*> <.>  regexp exponent
significand exponent <.> regexp floating

bl 1+ 127 [..] charClass not-white
not-white <+> regexp forth-word

\ To construct the syntax tree and associate token values with pattern names

case-insensitive

begin-symbols

"blk"             symbol blk             \ block
"block"           symbol block           \ block
"buffer"          symbol buffer          \ block
"flush"           symbol flush           \ block
"load"            symbol load            \ block
"save-buffers"    symbol save-buffers    \ block
"update"          symbol update          \ block
"empty-buffers"   symbol empty-buffers   \ blockext
"list"            symbol list            \ blockext
"scr"             symbol scr             \ blockext
"thru"            symbol thru            \ blockext
"!"               symbol !               \ core
"#"               symbol #               \ core
"#>"              symbol #>              \ core
"#s"              symbol #s              \ core
"'"               symbol '               \ core
"("               symbol (               \ core
"*"               symbol *               \ core
"*/"              symbol */              \ core
"*/mod"           symbol */mod           \ core
"+"               symbol +               \ core
"+!"              symbol +!              \ core
"+loop"           symbol +loop           \ core
","               symbol ,               \ core
"-"               symbol -               \ core
"."               symbol .               \ core
".""              symbol ."              \ core
"/"               symbol /               \ core
"/mod"            symbol /mod            \ core
"0<"              symbol 0<              \ core
"0="              symbol 0=              \ core
"1+"              symbol 1+              \ core
"1-"              symbol 1-              \ core
"2!"              symbol 2!              \ core
"2*"              symbol 2*              \ core
"2/"              symbol 2/              \ core
"2@"              symbol 2@              \ core
"2drop"           symbol 2drop           \ core
"2dup"            symbol 2dup            \ core
"2over"           symbol 2over           \ core
"2swap"           symbol 2swap           \ core
":"               symbol :               \ core
";"               symbol ;               \ core
"<"               symbol <               \ core
"<#"              symbol <#              \ core
"="               symbol =               \ core
">"               symbol >               \ core
">body"           symbol >body           \ core
">in"             symbol >in             \ core
">number"         symbol >number         \ core
">r"              symbol >r              \ core
"?dup"            symbol ?dup            \ core
"@"               symbol @               \ core
"abort"           symbol abort           \ core
"abort""	         symbol abort"          \ core
"abs"             symbol abs             \ core
"accept"          symbol accept          \ core
"align"           symbol align           \ core
"aligned"         symbol aligned         \ core
"allot"           symbol allot           \ core
"and"             symbol and             \ core
"base"            symbol base            \ core
"begin"           symbol begin           \ core
"bl"              symbol bl              \ core
"c!"              symbol c!              \ core
"c,"              symbol c,              \ core
"c@"              symbol c@              \ core
"cell+"           symbol cell+           \ core
"cells"           symbol cells           \ core
"char"            symbol char            \ core
"char+"           symbol char+           \ core
"chars"           symbol chars           \ core
"constant"        symbol constant        \ core
"count"           symbol count           \ core
"cr"              symbol cr              \ core
"create"          symbol create          \ core
"decimal"         symbol decimal         \ core
"depth"           symbol depth           \ core
"do"              symbol do              \ core
"does>"           symbol does>           \ core
"drop"            symbol drop            \ core
"dup"             symbol dup             \ core
"else"            symbol else            \ core
"emit"            symbol emit            \ core
"environment?"    symbol environment?    \ core
"evaluate"        symbol evaluate        \ core
"execute"         symbol execute         \ core
"exit"            symbol exit            \ core
"fill"            symbol fill            \ core
"find"            symbol find            \ core
"fm/mod"          symbol fm/mod          \ core
"here"            symbol here            \ core
"hold"            symbol hold            \ core
"i"               symbol i               \ core
"if"              symbol if              \ core
"immediate"       symbol immediate       \ core
"invert"          symbol invert          \ core
"j"               symbol j               \ core
"key"             symbol key             \ core
"leave"           symbol leave           \ core
"literal"         symbol literal         \ core
"loop"            symbol loop            \ core
"lshift"          symbol lshift          \ core
"m*"              symbol m*              \ core
"max"             symbol max             \ core
"min"             symbol min             \ core
"mod"             symbol mod             \ core
"move"            symbol move            \ core
"negate"          symbol negate          \ core
"or"              symbol or              \ core
"over"            symbol over            \ core
"postpone"        symbol postpone        \ core
"quit"            symbol quit            \ core
"r>"              symbol r>              \ core
"r@"              symbol r@              \ core
"recurse"         symbol recurse         \ core
"repeat"          symbol repeat          \ core
"rot"             symbol rot             \ core
"rshift"          symbol rshift          \ core
"s""	            symbol s"              \ core
"s>d"             symbol s>d             \ core
"sign"            symbol sign            \ core
"sm/rem"          symbol sm/rem          \ core
"source"          symbol source          \ core
"space"           symbol space           \ core
"spaces"          symbol spaces          \ core
"state"           symbol state           \ core
"swap"            symbol swap            \ core
"then"            symbol then            \ core
"type"            symbol type            \ core
"u."              symbol u.              \ core
"u<"              symbol u<              \ core
"um*"             symbol um*             \ core
"um/mod"          symbol um/mod          \ core
"unloop"          symbol unloop          \ core
"until"           symbol until           \ core
"variable"        symbol variable        \ core
"while"           symbol while           \ core
"word"            symbol word            \ core
"xor"             symbol xor             \ core
"["               symbol [               \ core
"[']"             symbol [']             \ core
"[char]"          symbol [char]          \ core
"]"               symbol ]               \ core
"#tib"            symbol #tib            \ coreext
".("              symbol .(              \ coreext
".r"              symbol .r              \ coreext
"0<>"             symbol 0<>             \ coreext
"0>"              symbol 0>              \ coreext
"2>r"             symbol 2>r             \ coreext
"2r>"             symbol 2r>             \ coreext
"2r@"             symbol 2r@             \ coreext
":noname"         symbol :noname         \ coreext
"<>"              symbol <>              \ coreext
"?do"             symbol ?do             \ coreext
"again"           symbol again           \ coreext
"c""	            symbol c"              \ coreext
"case"            symbol case            \ coreext
"compile,"        symbol compile,        \ coreext
"convert"         symbol convert         \ coreext
"endcase"         symbol endcase         \ coreext
"endof"           symbol endof           \ coreext
"erase"           symbol erase           \ coreext
"expect"          symbol expect          \ coreext
"false"           symbol false           \ coreext
"hex"             symbol hex             \ coreext
"marker"          symbol marker          \ coreext
"nip"             symbol nip             \ coreext
"of"              symbol of              \ coreext
"pad"             symbol pad             \ coreext
"parse"           symbol parse           \ coreext
"pick"            symbol pick            \ coreext
"query"           symbol query           \ coreext
"refill"          symbol refill          \ coreext
"restore-input"   symbol restore-input   \ coreext
"roll"            symbol roll            \ coreext
"save-input"      symbol save-input      \ coreext
"source-id"       symbol source-id       \ coreext
"span"            symbol span            \ coreext
"tib"             symbol tib             \ coreext
"to"              symbol to              \ coreext
"true"            symbol true            \ coreext
"tuck"            symbol tuck            \ coreext
"u.r"             symbol u.r             \ coreext
"u>"              symbol u>              \ coreext
"unused"          symbol unused          \ coreext
"value"           symbol value           \ coreext
"within"          symbol within          \ coreext
"[compile]"       symbol [compile]       \ coreext
"\"	            symbol \               \ coreext
"2constant"       symbol 2constant       \ double
"2literal"        symbol 2literal        \ double
"2variable"       symbol 2variable       \ double
"d+"              symbol d+              \ double
"d-"              symbol d-              \ double
"d."              symbol d.              \ double
"d.r"             symbol d.r             \ double
"d0<"             symbol d0<             \ double
"d0="             symbol d0=             \ double
"d2*"             symbol d2*             \ double
"d2/"             symbol d2/             \ double
"d<"              symbol d<              \ double
"d="              symbol d=              \ double
"d>s"             symbol d>s             \ double
"dabs"            symbol dabs            \ double
"dmax"            symbol dmax            \ double
"dmin"            symbol dmin            \ double
"dnegate"         symbol dnegate         \ double
"m*/"             symbol m*/             \ double
"m+"              symbol m+              \ double
"2rot"            symbol 2rot            \ doubleext
"du<"             symbol du<             \ doubleext
"catch"           symbol catch           \ exception
"throw"           symbol throw           \ exception
"at-xy"           symbol at-xy           \ facility
"key?"            symbol key?            \ facility
"page"            symbol page            \ facility
"ekey"            symbol ekey            \ facilityext
"ekey>char"       symbol ekey>char       \ facilityext
"ekey?"           symbol ekey?           \ facilityext
"emit?"           symbol emit?           \ facilityext
"ms"              symbol ms              \ facilityext
"time&date"       symbol time&date       \ facilityext
"bin"             symbol bin             \ file
"close-file"      symbol close-file      \ file
"create-file"     symbol create-file     \ file
"delete-file"     symbol delete-file     \ file
"file-position"   symbol file-position   \ file
"file-size"       symbol file-size       \ file
"included"        symbol included        \ file
"include-file"    symbol include-file    \ file
"open-file"       symbol open-file       \ file
"r/o"             symbol r/o             \ file
"r/w"             symbol r/w             \ file
"read-file"       symbol read-file       \ file
"read-line"       symbol read-line       \ file
"reposition-file" symbol reposition-file \ file
"resize-file"     symbol resize-file     \ file
"w/o"             symbol w/o             \ file
"write-file"      symbol write-file      \ file
"write-line"      symbol write-line      \ file
"file-status"     symbol file-status     \ fileext
"flush-file"      symbol flush-file      \ fileext
"rename-file"     symbol rename-file     \ fileext
">float"          symbol >float          \ floating
"d>f"             symbol d>f             \ floating
"f!"              symbol f!              \ floating
"f*"              symbol f*              \ floating
"f+"              symbol f+              \ floating
"f-"              symbol f-              \ floating
"f/"              symbol f/              \ floating
"f0<"             symbol f0<             \ floating
"f0="             symbol f0=             \ floating
"f<"              symbol f<              \ floating
"f>d"             symbol f>d             \ floating
"f@"              symbol f@              \ floating
"falign"          symbol falign          \ floating
"faligned"        symbol faligned        \ floating
"fconstant"       symbol fconstant       \ floating
"fdepth"          symbol fdepth          \ floating
"fdrop"           symbol fdrop           \ floating
"fdup"            symbol fdup            \ floating
"fliteral"        symbol fliteral        \ floating
"float+"          symbol float+          \ floating
"floats"          symbol floats          \ floating
"floor"           symbol floor           \ floating
"fmax"            symbol fmax            \ floating
"fmin"            symbol fmin            \ floating
"fnegate"         symbol fnegate         \ floating
"fover"           symbol fover           \ floating
"frot"            symbol frot            \ floating
"fround"          symbol fround          \ floating
"fswap"           symbol fswap           \ floating
"fvariable"       symbol fvariable       \ floating
"represent"       symbol represent       \ floating
"df!"             symbol df!             \ floatingext
"df@"             symbol df@             \ floatingext
"dfalign"         symbol dfalign         \ floatingext
"dfaligned"       symbol dfaligned       \ floatingext
"dfloat+"         symbol dfloat+         \ floatingext
"dfloats"         symbol dfloats         \ floatingext
"f**"             symbol f**             \ floatingext
"f."              symbol f.              \ floatingext
"fabs"            symbol fabs            \ floatingext
"facos"           symbol facos           \ floatingext
"facosh"          symbol facosh          \ floatingext
"falog"           symbol falog           \ floatingext
"fasin"           symbol fasin           \ floatingext
"fasinh"          symbol fasinh          \ floatingext
"fatan"           symbol fatan           \ floatingext
"fatan2"          symbol fatan2          \ floatingext
"fatanh"          symbol fatanh          \ floatingext
"fcos"            symbol fcos            \ floatingext
"fcosh"           symbol fcosh           \ floatingext
"fe."             symbol fe.             \ floatingext
"fexp"            symbol fexp            \ floatingext
"fexpm1"          symbol fexpm1          \ floatingext
"fln"             symbol fln             \ floatingext
"flnp1"           symbol flnp1           \ floatingext
"flog"            symbol flog            \ floatingext
"fs."             symbol fs.             \ floatingext
"fsin"            symbol fsin            \ floatingext
"fsincos"         symbol fsincos         \ floatingext
"fsinh"           symbol fsinh           \ floatingext
"fsqrt"           symbol fsqrt           \ floatingext
"ftan"            symbol ftan            \ floatingext
"ftanh"           symbol ftanh           \ floatingext
"f~"              symbol f~              \ floatingext
"precision"       symbol precision       \ floatingext
"set-precision"   symbol set-precision   \ floatingext
"sf!"             symbol sf!             \ floatingext
"sf@"             symbol sf@             \ floatingext
"sfalign"         symbol sfalign         \ floatingext
"sfaligned"       symbol sfaligned       \ floatingext
"sfloat+"         symbol sfloat+         \ floatingext
"sfloats"         symbol sfloats         \ floatingext
"(local)"         symbol (local)         \ local
"locals|"         symbol locals|         \ localext
"allocate"        symbol allocate        \ memory
"free"            symbol free            \ memory
"resize"          symbol resize          \ memory
"definitions"     symbol definitions     \ search
"forth-wordlist"  symbol forth-wordlist  \ search
"get-current"     symbol get-current     \ search
"get-order"       symbol get-order       \ search
"search-wordlist" symbol search-wordlist \ search
"set-current"     symbol set-current     \ search
"set-order"       symbol set-order       \ search
"wordlist"        symbol wordlist        \ search
"also"            symbol also            \ searchext
"forth"           symbol forth           \ searchext
"only"            symbol only            \ searchext
"order"           symbol order           \ searchext
"previous"        symbol previous        \ searchext
"-trailing"       symbol -trailing       \ string
"/string"         symbol /string         \ string
"blank"           symbol blank           \ string
"cmove"           symbol cmove           \ string
"cmove>"          symbol cmove>          \ string
"compare"         symbol compare         \ string
"search"          symbol search          \ string
"sliteral"        symbol sliteral        \ string
".s"              symbol .s              \ tools
"?"               symbol ?               \ tools
"dump"            symbol dump            \ tools
"see"             symbol see             \ tools
"words"           symbol words           \ tools
";code"           symbol ;code           \ toolsext
"ahead"           symbol ahead           \ toolsext
"assembler"       symbol assembler       \ toolsext
"bye"             symbol bye             \ toolsext
"code"            symbol code            \ toolsext
"cs-pick"         symbol cs-pick         \ toolsext
"cs-roll"         symbol cs-roll         \ toolsext
"editor"          symbol editor          \ toolsext
"forget"          symbol forget          \ toolsext
"[else]"          symbol [else]          \ toolsext
"[if]"            symbol [if]            \ toolsext
"[then]"          symbol [then]          \ toolsext

"ws"              denotes white-space    \ Not an ANS word
"number"          denotes number         \ Decimal number or double number
"floating"        denotes floating       \ Floating point number
"forth-word"      denotes forth-word     \ Any character string without spaces

end-symbols syntaxTree

syntaxTree lexgen

